"use strict";

var CodeError = require('../utils/CodeError');

var getPagePath = require('../utils/getPagePath');

module.exports = function visitor(_ref, _ref2) {
  var t = _ref.types;
  var nativeLifeCycleMap = _ref2.nativeLifeCycleMap;
  return {
    visitor: {
      CallExpression: function CallExpression(path, _ref3) {
        var filename = _ref3.filename,
            code = _ref3.file.code;
        var pagePath = getPagePath(filename);

        if (pagePath) {
          var nativeLifeCycle = nativeLifeCycleMap[pagePath];

          if (t.isIdentifier(path.node.callee, {
            name: 'registerNativeEventListeners'
          })) {
            if (t.isArrayExpression(path.node.arguments[1])) {
              path.node.arguments[1].elements.forEach(function (element) {
                nativeLifeCycle[element.value] = true;
              });
            } else {
              throw new CodeError(code, path.node.loc, "registerNativeEventListeners's second argument should be an array, like ['onReachBottom']");
            }
          }
        }
      }
    }
  };
};